> ## Documentation Index
> Fetch the complete documentation index at: https://docs.onswitch.xyz/llms.txt
> Use this file to discover all available pages before exploring further.

# Get transactions

> List transactions for a wallet with optional pagination.



## OpenAPI

````yaml /openapi.json get /wallet/{wallet_id}/transactions
openapi: 3.0.3
info:
  title: Receive stablecoin. Get fiat in seconds.
  description: Stablecoin collection and settlement layer.
  version: 1.0.0
  contact:
    name: Switch Labs
    email: contact@onswitch.xyz
  license:
    name: Proprietary
  x-tagGroups:
    - name: Institution
      tags:
        - Institution
    - name: Miscellaneous
      tags:
        - Miscellaneous
    - name: History
      tags:
        - History
    - name: Payment
      tags:
        - Payment
    - name: Webhook
      tags:
        - Webhook
    - name: Offramp
      tags:
        - Offramp
    - name: Onramp
      tags:
        - Onramp
    - name: Swap
      tags:
        - Swap
    - name: Developer
      tags:
        - Developer
    - name: Wallet
      tags:
        - Wallet
    - name: Compliance
      tags:
        - Compliance
servers:
  - url: https://api.onswitch.xyz
    description: Production server
security: []
tags:
  - name: Institution
    description: Institution discovery and bank or payment-rail lookup
  - name: Miscellaneous
    description: Requirements, coverage, assets, confirmation, and transaction status
  - name: History
    description: Payment history and summaries for the partner's account
  - name: Payment
    description: Saved payment beneficiaries, payment confirmation, and status
  - name: Webhook
    description: Webhook delivery history and callback resend
  - name: Offramp
    description: Offramp transaction endpoints for converting stablecoins to local currency
  - name: Onramp
    description: Onramp transaction endpoints for converting local currency to stablecoins
  - name: Swap
    description: Swap endpoints for exchanging between different stablecoin assets
  - name: Developer
    description: Developer fee balance and withdrawal
  - name: Wallet
    description: >-
      Wallet endpoints for creating and managing chain abstracted stablecoin
      wallets
  - name: Compliance
    description: AML compliance screening for PEP, sanctions, and other regulatory reasons
paths:
  /wallet/{wallet_id}/transactions:
    get:
      tags:
        - Wallet
      summary: Get transactions
      description: List transactions for a wallet with optional pagination.
      operationId: getWalletTransactions
      parameters:
        - name: wallet_id
          in: path
          required: true
          description: Wallet ID (24-character hex)
          schema:
            type: string
            pattern: ^[a-f0-9]{24}$
        - name: page
          in: query
          required: false
          description: Page number (1-based)
          schema:
            type: integer
            minimum: 1
            default: 1
        - name: limit
          in: query
          required: false
          description: Number of items per page (max 100)
          schema:
            type: integer
            minimum: 1
            maximum: 100
            default: 100
      responses:
        '200':
          description: Transactions retrieved successfully
          content:
            application/json:
              schema:
                type: object
                required:
                  - success
                  - message
                  - timestamp
                  - data
                properties:
                  success:
                    type: boolean
                  message:
                    type: string
                  timestamp:
                    type: string
                    format: date-time
                  data:
                    type: array
                    items:
                      type: object
                      properties:
                        reference:
                          type: string
                          format: uuid
                          description: Transaction reference (UUID)
                        amount:
                          type: number
                          nullable: true
                          description: Transaction amount (from input)
                        asset:
                          type: string
                          nullable: true
                          description: Asset ID from input (e.g. base:usdc)
                        transaction_hash:
                          type: string
                          nullable: true
                        explorer_url:
                          type: string
                          nullable: true
                          format: uri
                        type:
                          $ref: '#/components/schemas/WalletTransactionType'
                        date:
                          type: string
                          format: date-time
                          nullable: true
                        sender:
                          type: string
                          nullable: true
                        receiver:
                          type: string
                          nullable: true
                        status:
                          type: string
                          enum:
                            - successful
                            - failed
                            - processing
                        fee:
                          type: object
                          nullable: true
                          properties:
                            amount:
                              type: number
                            assets:
                              type: array
                              items:
                                type: object
                                properties:
                                  id:
                                    type: string
                                  amount:
                                    type: number
                        input:
                          type: object
                          nullable: true
                          properties:
                            amount:
                              type: number
                            assets:
                              type: array
                              items:
                                type: object
                                properties:
                                  id:
                                    type: string
                                  amount:
                                    type: number
                        output:
                          type: object
                          nullable: true
                          properties:
                            amount:
                              type: number
                            assets:
                              type: array
                              items:
                                type: object
                                properties:
                                  id:
                                    type: string
                                  amount:
                                    type: number
              example:
                success: true
                message: Wallet transactions fetched successfully
                timestamp: '2026-04-18T14:22:08.631Z'
                data:
                  - reference: 2a96f96e-f29e-49de-913d-17c4ea23a517
                    amount: 5
                    asset: base:usdc
                    type: send
                    status: successful
                    date: '2026-04-18T09:43:11.000Z'
                    transaction_hash: >-
                      0xd078bb42505b9e80dc40d9e93753c83a8019e8bfc8990e352bfce0379beb2354
                    explorer_url: >-
                      https://blockscan.com/tx/0xd078bb42505b9e80dc40d9e93753c83a8019e8bfc8990e352bfce0379beb2354
                    sender: '0xef6e423ad6ad3855c38417ef4d6a459126009d74'
                    receiver: '0x968a31b0b3bc698e75cd030cd2a69b7395b190da'
                  - reference: 4e55e9f4-55ea-4df4-9cea-4e1f7b9cf759
                    amount: 0.181067
                    asset: polygon:usdc
                    type: fee
                    status: successful
                    date: '2026-04-18T09:43:10.000Z'
                    transaction_hash: >-
                      0xfa93cefb230af021499c3529ea50e934f44964d2261b8f1c15220a7f764713f3
                    explorer_url: >-
                      https://blockscan.com/tx/0xfa93cefb230af021499c3529ea50e934f44964d2261b8f1c15220a7f764713f3
                    sender: '0xef6e423ad6ad3855c38417ef4d6a459126009d74'
                    receiver: '0xbeb44c790dbe563aff6e649d42ebc44cbde92dc0'
                  - reference: 53cc6c5b-e323-4f0f-acad-c4e39259176e
                    amount: 15
                    asset: polygon:usdc
                    type: receive
                    status: successful
                    date: '2026-04-18T09:15:56.000Z'
                    transaction_hash: >-
                      0xbeab691e6a9dee2d52d4d656676a712257fd075740e7278065d2f6458d5070da
                    explorer_url: >-
                      https://blockscan.com/tx/0xbeab691e6a9dee2d52d4d656676a712257fd075740e7278065d2f6458d5070da
                    sender: '0xa85c29b94f8a22a7268facee89ef4eca051be2ce'
                    receiver: '0xef6e423ad6ad3855c38417ef4d6a459126009d74'
        '400':
          $ref: '#/components/responses/BadRequest'
      security:
        - ServiceKey: []
components:
  schemas:
    WalletTransactionType:
      type: string
      description: Wallet transactions type.
      enum:
        - send
        - receive
        - fee
  responses:
    BadRequest:
      description: Bad request - Invalid input parameters or validation error
      content:
        application/json:
          schema:
            type: object
            required:
              - success
              - message
              - timestamp
            properties:
              success:
                type: boolean
                example: false
              message:
                type: string
                description: Error message describing what went wrong
              timestamp:
                type: string
                format: date-time
              data:
                description: Additional error details
                nullable: true
          example:
            success: false
            message: amount must be greater than 0 for the selected corridor
            timestamp: '2026-04-18T14:22:08.631Z'
            data: null
  securitySchemes:
    ServiceKey:
      type: apiKey
      in: header
      name: x-service-key
      description: Service key for API authentication

````